## How to contribute

If you would like to contribute to the development and maintenance of *sierra-local*, great!  We are trying to adhere to the following style conventions for Python code:

* Use a block quote at the top of a new script to briefly describe its purpose.
* Indent with 4 spaces.
* Variable names should use lowercase and underscores.
* Constants are named with uppercase and underscores, *e.g.*, `SEQUENCE_SHRINKAGE_WINDOW`
* Function names should use camelCase.
* Functions should have a block quote in the first few lines to provide a description and to list input parameters and return values.

## How to report issues

* We use the GitHub issue tracker to report and coordinate work on issues.  
* If you encounter a bug, please search the issue tracker for related issues before creating a new issue.  Mark the issue with a *bug* tag.
* Please provide the following information:
  * the *sierra-local* release version number or commit
  * operating system
  * Python version
  * a brief description of the problem
  * if appropriate, an informative excerpt of traceback or error messages returned by the program, enclosed in triple ticks.
* If you are requesting a new feature, please create a new issue and mark it with an *enhancement* tag.

## How to get help
* Check the [issue tracker](https://github.com/PoonLab/sierra-local/issues).  It is quite likely that one of us has encountered the same problem you're facing before!  You might find it helpful to search the issues without the `is:open` flag, so that you can check closed (resolved) issues as well.
* If you have a [GitHub account](https://github.com/join), you are welcome to post an issue on the [sierra-local issue tracker](https://github.com/PoonLab/sierra-local/issues).  Please tag your issue with a `question` label so that it stands out from the other issues.
* If you are an end-user at an academic organization or clinical laboratory, you can contact [Art](https://www.schulich.uwo.ca/pathol/people/bios/faculty/poon_art.html) (currently package maintainer) at his work e-mail (see `AUTHORS` file).
